An Update to YANG Module Names Registration
RFC 9890
Andy Bierman
YumaWorks
Mohamed Boucadair, Ed.
Orange
Qin Wu
Huawei
2025-10
OPS
netmod
NETCONF
RESTCONF
Automation
This document amends the IANA guidance on the uniqueness of YANG module and submodule names.
The document updates RFC 6020 to clarify how modules and their revisions are handled by IANA.
Status of This Memo
This is an Internet Standards Track document.
This document is a product of the Internet Engineering Task Force (IETF). It represents the consensus of the IETF community. It has received public review and has been approved for publication by the Internet Engineering Steering Group (IESG). Further information on Internet Standards is available in Section 2 of RFC 7841.
Information about the current status of this document, any errata, and how to provide feedback on it may be obtained at https://www.rfc-editor.org/info/rfc9890.
Copyright Notice
Copyright (c) 2025 IETF Trust and the persons identified as the document authors. All rights reserved.
This document is subject to BCP 78 and the IETF Trust's Legal Provisions Relating to IETF Documents (https://trustee.ietf.org/license-info) in effect on the date of publication of this document. Please review these documents carefully, as they describe your rights and restrictions with respect to this document. Code Components extracted from this document must include Revised BSD License text as described in Section 4.e of the Trust Legal Provisions and are provided without warranty as described in the Revised BSD License.
Table of Contents
- 1. Introduction
- 2. Requirements Notation
- 3. IANA Considerations
  - 3.1. Update YANG Parameters Registry
  - 3.2. Revisions of Published Modules
- 4. Operational Considerations
- 5. Security Considerations
- 6. References
  - 6.1. Normative References
  - 6.2. Informative References
- Acknowledgments
- Authors' Addresses
Introduction
[RFC6020] defines a registry for YANG module and submodule names, called "YANG Module Names" [IANA-MOD-NAMES].
Specifically, IANA considerations to register YANG module and submodule names are specified in Section 14 of [RFC6020]. These considerations require that all module and submodule names in the registry must be unique. However, the practice followed by IANA is not consistent with that guidance.
This document amends the guidance on the uniqueness of names (Section 14 of [RFC6020]) to comply with the IANA practices for registering modules and their revisions.
Requirements Notation
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
IANA Considerations
Update YANG Parameters Registry
IANA has updated the "YANG Module Names" registry under the "YANG Parameters" registry group [IANA-MOD-NAMES] to list this document as an additional reference. This update is needed because the procedure in this document is authoritative for assigning names in that registry.
Revisions of Published Modules
This document amends the guidance on the uniqueness of names, initially defined in Section 14 of [RFC6020], as follows:
OLD:
All module and submodule names in the registry MUST be unique.
All XML namespaces in the registry MUST be unique.
NEW:
Modules and their revisions are maintained in the registry.
All initial version module and submodule names in the registry MUST be unique.
All XML namespaces of initial version modules in the registry MUST be unique.
All module and submodule revisions MUST have the same name as the one in the initial version of the module and submodule.
All module revisions MUST have the same XML namespace as the initial version of the module.
Operational Considerations
This document aligns an IANA policy with the practice for handling YANG module names (Section 3.2). As such, there are no new operations or manageability requirements introduced by this document.
Security Considerations
This document defines a new IANA action (Section 3.1) and an update (Section 3.2) to an IANA registration procedure defined in [RFC6020]. It does not introduce any new or increased security risks that need to be discussed.
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC6020]

YANG - A Data Modeling Language for the Network Configuration Protocol (NETCONF)
M. Bjorklund, Ed.
October 2010
RFC 6020
DOI 10.17487/RFC6020
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[IANA-MOD-NAMES]

YANG Module Names
IANA
[I-D.ietf-netmod-rfc8407bis]

Guidelines for Authors and Reviewers of Documents Containing YANG Data Models
Andy Bierman
YumaWorks
Mohamed Boucadair, Ed.
Orange
Qin Wu
Huawei
5 June 2025
Internet-Draft draft-ietf-netmod-rfc8407bis-28
Work in Progress
Acknowledgments
The content of this document was part of [YANG-GUIDE].
Mahesh Jethanandani suggested to offload this part from [YANG-GUIDE]. Thanks to Mahesh and Kent Watsen for the discussion and comments.
Thanks to Mallory Knodel for the GENART review and Barry Leiba for the ARTART review.
Thanks Mike Bishop for the IESG review.
Authors' Addresses
Andy Bierman
YumaWorks
United States of America
andy@yumaworks.com
Mohamed Boucadair, Ed.
Orange
France
mohamed.boucadair@orange.com
Qin Wu
Huawei
China
bill.wu@huawei.com